/*
 * Copyright 2004-2006 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.dao.pager;

import java.sql.PreparedStatement;

import org.aopalliance.intercept.MethodInvocation;
import org.seasar.dao.interceptors.S2DaoInterceptor;
import org.seasar.framework.aop.interceptors.AbstractInterceptor;

/**
 * y[WpS2DaoInterceptor̃bp[B
 * PagerContextɈZbgāA
 * S2DaoInterceptorĂяo܂B<p>
 * 
 * ̃V[PXɂAy[WOs܂B
 * <ol>
 * <li>PagerS2DaoInterceptorWrapperPagerContextɃZbg܂B</li>
 * <li>PagerResultSetFactoryWrapperPagerCondition擾PagerResultSetWrapperɃZbg܂B</li>
 * <li>PagerResultSetWrapperPagerConditionɎw肳ꂽ͈͂̌ʃZbgԂ܂B</li>
 * <li>PagerResultSetWrapperResultSet̑PagerConditionɃZbg܂B</li>
 * </ol>
 * 
 * @author Toshitaka Agata(Nulab,inc.)
 * @see PagerContext#pushArgs(Object[])
 * @see PagerResultSetFactoryWrapper#createResultSet(PreparedStatement)
 * @see PagerResultSetWrapper#next()
 */
public class PagerS2DaoInterceptorWrapper extends AbstractInterceptor {

    private static final long serialVersionUID = 1L;

    /** IWiS2DaoInterceptor */
    private S2DaoInterceptor interceptor_;

    /**
     * RXgN^
     * @param interceptor IWiS2DaoInterceptor
     */
    public PagerS2DaoInterceptorWrapper(S2DaoInterceptor interceptor) {
        this.interceptor_ = interceptor;
    }

    /**
     * @see org.aopalliance.intercept.MethodInterceptor#invoke(org.aopalliance.intercept.MethodInvocation)
     */
    public Object invoke(MethodInvocation invocation) throws Throwable {
        try {
            PagerContext.getContext().pushArgs(invocation.getArguments());
            return interceptor_.invoke(invocation);
        } finally {
            PagerContext.getContext().popArgs();
        }
    }
}